com.smartgwt.client.widgets.form.fields

## Class MultiComboBoxItem

- java.lang.Object
- - com.smartgwt.client.core.JsObject
  - - com.smartgwt.client.core.DataClass
    - - com.smartgwt.client.core.RefDataClass
      - - com.smartgwt.client.widgets.form.fields.FormItem
        - - com.smartgwt.client.widgets.form.fields.CanvasItem
          - - com.smartgwt.client.widgets.form.fields.MultiComboBoxItem

- All Implemented Interfaces:
    com.google.gwt.event.shared.HasHandlers, HasBlurHandlers, HasCanEditChangedHandlers, HasChangedHandlers, HasChangeHandlers, HasClickHandlers, HasDoubleClickHandlers, HasEditorEnterHandlers, HasEditorExitHandlers, HasFocusHandlers, HasIconClickHandlers, HasIconKeyPressHandlers, HasItemHoverHandlers, HasKeyDownHandlers, HasKeyPressHandlers, HasKeyUpHandlers, HasPickerIconClickHandlers, HasShowValueHandlers, HasTitleClickHandlers, HasTitleDoubleClickHandlers, HasTitleHoverHandlers, HasValueHoverHandlers

      public class MultiComboBoxItem
      extends CanvasItem

  A MultiComboBoxItem is a combo box that allows the user to select multiple options. Each selected option is represented as a button that can be clicked to deselect the option. The relative layout of the buttons to the combo box is specified with the `layoutStyle` attribute. The buttons will be kept in the order that they were added, with the most recently added button being adjacent to the combo box. MultiComboBoxItem uses the AutoChild pattern to construct the combo box and the buttons so that they can be easily customized.
  See Also:
    `ComboBoxItem`

- - ### Field Summary

    - ### Fields inherited from class com.smartgwt.client.core.RefDataClass

      `id`

    - ### Fields inherited from class com.smartgwt.client.core.JsObject

      `jsObj`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `MultiComboBoxItem()`
    `MultiComboBoxItem(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `MultiComboBoxItem(java.lang.String name)`
    `MultiComboBoxItem(java.lang.String name, java.lang.String title)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, Canvas defaults)` Changes the defaults for Canvas AutoChildren named `autoChildName`.
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, FormItem defaults)` Changes the defaults for FormItem AutoChildren named `autoChildName`.
    `static void` | `changePickerIconDefaults(FormItemIcon defaults)`
    `java.lang.Boolean` | `getAutoFetchData()` Should the MultiComboBoxItem fetch data from the `data source` immediately or wait until the user first opens the pickList.
    `java.lang.Boolean` | `getAutoFitButtons()` Specifies whether to autofit the buttons in the MultiComboBoxItem.
    `IButton` | `getButtonDefaults()` Default properties to be used in creating each `IButton`.
    `IButton` | `getButtonProperties()` Properties to be used in creating each option button.
    `ComboBoxItem` | `getComboBoxDefaults()` Default properties for the `ComboBoxItem` in a MultiComboBoxItem.
    `ComboBoxItem` | `getComboBoxProperties()` Properties to be used in creating a `ComboBoxItem`.
    `java.lang.Integer` | `getComboBoxWidth()` Specifies the size of the combo box field.
    `java.lang.String` | `getDisplayField()` The `displayField` of the combo box.
    `MultiComboBoxLayoutStyle` | `getLayoutStyle()` Specifies the layout style of the combo box and the buttons in the MultiComboBoxItem.
    `DataSource` | `getOptionDataSource()` The `optionDataSource` of the combo box.
    `static MultiComboBoxItem` | `getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `java.lang.Boolean` | `getShouldSaveValue()` Should this item's value be saved in the form's values and hence returned from `form.getValues()`?
    `java.lang.Boolean` | `getUseInsertionOrder()` Specifies whether to arrange the buttons of the MultiComboBoxItem in the order that they were selected (the default), or to sort the buttons by `displayField`.
    `java.lang.String` | `getValueField()` The `valueField` of the combo box.
    `java.lang.String[]` | `getValues()`
    `void` | `setAutoFetchData(java.lang.Boolean autoFetchData)` Should the MultiComboBoxItem fetch data from the `data source` immediately or wait until the user first opens the pickList.
    `void` | `setAutoFitButtons(java.lang.Boolean autoFitButtons)` Specifies whether to autofit the buttons in the MultiComboBoxItem.
    `void` | `setButtonProperties(IButton buttonProperties)` Properties to be used in creating each option button.
    `void` | `setComboBoxProperties(ComboBoxItem comboBoxProperties)` Properties to be used in creating a `ComboBoxItem`.
    `void` | `setComboBoxWidth(java.lang.Integer comboBoxWidth)` Specifies the size of the combo box field.
    `static void` | `setDefaultProperties(MultiComboBoxItem multiComboBoxItemProperties)` Class level method to set the default properties of this class.
    `void` | `setDisplayField(java.lang.String displayField)` The `displayField` of the combo box.
    `void` | `setJavaScriptObject(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `void` | `setLayoutStyle(MultiComboBoxLayoutStyle layoutStyle)` Specifies the layout style of the combo box and the buttons in the MultiComboBoxItem.
    `void` | `setOptionDataSource(DataSource optionDataSource)` The `optionDataSource` of the combo box.
    `void` | `setShouldSaveValue(java.lang.Boolean shouldSaveValue)` Should this item's value be saved in the form's values and hence returned from `form.getValues()`?
    `void` | `setUseInsertionOrder(java.lang.Boolean useInsertionOrder)` Specifies whether to arrange the buttons of the MultiComboBoxItem in the order that they were selected (the default), or to sort the buttons by `displayField`.
    `void` | `setValueField(java.lang.String valueField)` The `valueField` of the combo box.
    `void` | `setValues(java.lang.Object... values)`
    `void` | `showValue(java.lang.Object displayValue, java.lang.Object dataValue, DynamicForm form, CanvasItem item)` This method will be called whenever this form item's value is being set via a programmatic call to e.g: `DynamicForm.setValues` or `FormItem.setValue` and may be overridden by CanvasItems intended to support displaying data values to update the embedded Canvas to reflect the value passed in.

    - ### Methods inherited from class com.smartgwt.client.widgets.form.fields.CanvasItem

      `addCanEditChangedHandler, addShowValueHandler, createCanvas, getApplyPromptToCanvas, getAutoDestroy, getCanvas, getEditCriteriaInInnerForm, getHeight, getMultiple, getOverflow, getPrompt, hasAdvancedCriteria, readOnlyDisplayChanged, setApplyPromptToCanvas, setAutoDestroy, setCanEditCriterionPredicate, setCanvas, setCriterionGetter, setCriterionSetter, setDefaultProperties, setEditCriteriaInInnerForm, setMultiple, setOverflow, setPrompt, setupCanvasConstructor, storeValue, storeValue, storeValue`

    - ### Methods inherited from class com.smartgwt.client.widgets.form.fields.FormItem

      `_getValue, addBlurHandler, addChangedHandler, addChangeHandler, addClickHandler, addDoubleClickHandler, addEditorEnterHandler, addEditorExitHandler, addFocusHandler, addIconClickHandler, addIconKeyPressHandler, addItemHoverHandler, addKeyDownHandler, addKeyPressHandler, addKeyUpHandler, addPickerIconClickHandler, addTitleClickHandler, addTitleDoubleClickHandler, addTitleHoverHandler, addValueHoverHandler, asSGWTComponent, blurItem, canEditCriterion, clearValue, disable, enable, focusInItem, getAccessKey, getAlign, getAllowExpressions, getAlwaysFetchMissingValues, getApplyHeightToTextBox, getAriaRole, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDouble, getAttributeAsFloat, getAttributeAsInt, getAttributeAsJavaScriptObject, getAttributeAsString, getBrowserSpellCheck, getCanEdit, getCanFocus, getCanvasAutoChild, getCellHeight, getCellStyle, getClassName, getClipStaticValue, getClipTitle, getConfig, getContainerWidget, getCriteriaField, getCriterion, getCriterion, getDataPath, getDateFormatter, getDecimalPad, getDecimalPrecision, getDefaultIconSrc, getDisabled, getDisableIconsOnReadOnly, getDisplayFieldName, getDisplayValue, getDisplayValue, getEditorTypeConfig, getEditPendingCSSText, getEmptyDisplayValue, getEmptyValueIcon, getEndRow, getErrorIconHeight, getErrorIconSrc, getErrorIconWidth, getErrorMessageWidth, getFetchMissingValues, getFieldName, getFilterLocally, getForm, getFormItemAutoChild, getFullDataPath, getGlobalTabIndex, getHint, getHintStyle, getHoverAlign, getHoverDelay, getHoverHeight, getHoverOpacity, getHoverStyle, getHoverVAlign, getHoverWidth, getIcon, getIconHeight, getIconHSpace, getIconPageRect, getIconPrompt, getIconRect, getIconVAlign, getIconWidth, getImageURLPrefix, getImageURLSuffix, getImplicitSave, getImplicitSaveOnBlur, getInputFormat, getLeft, getLocateItemBy, getMultipleValueSeparator, getName, getOperator, getOptionCriteria, getOptionFilterContext, getOptionOperationId, getPageLeft, getPageRect, getPageTop, getPicker, getPickerIconHeight, getPickerIconName, getPickerIconPrompt, getPickerIconProperties, getPickerIconSrc, getPickerIconStyle, getPickerIconWidth, getPrintTextBoxStyle, getPrintTitleStyle, getReadOnlyDisplay, getReadOnlyTextBoxStyle, getRect, getRedrawOnChange, getRejectInvalidValueOnChange, getRequired, getRequiredMessage, getRowSpan, getSaveOnEnter, getSelectedRecord, getSelectOnClick, getSelectOnFocus, getShowClippedTitleOnHover, getShowClippedValueOnHover, getShowDisabled, getShowErrorIcon, getShowErrorStyle, getShowErrorText, getShowFocused, getShowFocusedErrorState, getShowFocusedIcons, getShowFocusedPickerIcon, getShowHint, getShowIcons, getShowOverIcons, getShowPickerIcon, getShowRTL, getShowTitle, getShowValueIconOnly, getStartRow, getStopOnError, getSuppressValueIcon, getSynchronousValidation, getTabIndex, getTextAlign, getTextBoxStyle, getTimeFormatter, getTitle, getTitleAlign, getTitleColSpan, getTitleOrientation, getTitleStyle, getTitleVAlign, getTooltip, getTop, getType, getValidateOnChange, getValidateOnExit, getValidOperators, getVAlign, getValue, getValueAsRecordList, getValueFieldName, getValueIconHeight, getValueIconLeftPadding, getValueIconRightPadding, getValueIconSize, getValueIconWidth, getVisible, getVisibleHeight, getVisibleWidth, getWidth, getWrapTitle, hide, hideIcon, invalidateDisplayValueCache, isCreated, isDisabled, isDrawn, isVisible, redraw, setAccessKey, setAlign, setAllowExpressions, setAlwaysFetchMissingValues, setApplyHeightToTextBox, setAriaRole, setAriaState, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setBrowserSpellCheck, setCanEdit, setCanFocus, setCellHeight, setCellStyle, setClipStaticValue, setClipTitle, setColSpan, setColSpan, setCriteriaField, setCriterion, setDataPath, setDateFormatter, setDecimalPad, setDecimalPrecision, setDefaultIconSrc, setDefaultProperties, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDisabled, setDisableIconsOnReadOnly, setDisplayFormat, setDisplayFormat, setEditorProperties, setEditorType, setEditorType, setEditorType, setEditorValueFormatter, setEditorValueParser, setEditPendingCSSText, setEmptyDisplayValue, setEmptyValueIcon, setEndRow, setErrorFormatter, setErrorIconHeight, setErrorIconSrc, setErrorIconWidth, setErrorMessageWidth, setErrorOrientation, setFetchMissingValues, setFilterLocally, setGlobalTabIndex, setHeight, setHeight, setHint, setHintStyle, setHoverAlign, setHoverDelay, setHoverHeight, setHoverOpacity, setHoverStyle, setHoverVAlign, setHoverWidth, setIconHeight, setIconHSpace, setIconPrompt, setIcons, setIconVAlign, setIconWidth, setImageURLPrefix, setImageURLSuffix, setImplicitSave, setImplicitSaveOnBlur, setInitHandler, setInputFormat, setInputTransformer, setItemHoverFormatter, setItemTitleHoverFormatter, setItemValueHoverFormatter, setLeft, setLocateItemBy, setMultipleValueSeparator, setName, setOperator, setOptionCriteria, setOptionFilterContext, setOptionOperationId, setPickerIconHeight, setPickerIconName, setPickerIconPrompt, setPickerIconProperties, setPickerIconSrc, setPickerIconStyle, setPickerIconWidth, setPrintTextBoxStyle, setPrintTitleStyle, setProperty, setProperty, setProperty, setProperty, setProperty, setReadOnlyDisplay, setReadOnlyTextBoxStyle, setRedrawOnChange, setRejectInvalidValueOnChange, setRequired, setRequiredMessage, setRowSpan, setSaveOnEnter, setSelectOnClick, setSelectOnFocus, setShowClippedTitleOnHover, setShowClippedValueOnHover, setShowDisabled, setShowErrorIcon, setShowErrorStyle, setShowErrorText, setShowFocused, setShowFocusedErrorState, setShowFocusedIcons, setShowFocusedPickerIcon, setShowHint, setShowIcons, setShowIfCondition, setShowOverIcons, setShowPickerIcon, setShowRTL, setShowTitle, setShowValueIconOnly, setStartRow, setStopOnError, setSuppressValueIcon, setSynchronousValidation, setTabIndex, setTextAlign, setTextBoxStyle, setTimeFormatter, setTitle, setTitleAlign, setTitleColSpan, setTitleHoverFormatter, setTitleOrientation, setTitleStyle, setTitleVAlign, setTooltip, setTop, setType, setValidateOnChange, setValidateOnExit, setValidators, setValidOperators, setVAlign, setValue, setValue, setValue, setValue, setValue, setValue, setValueFormatter, setValueHoverFormatter, setValueIconHeight, setValueIconLeftPadding, setValueIconMapper, setValueIconRightPadding, setValueIcons, setValueIconSize, setValueIconWidth, setValueMap, setValueMap, setVisible, setWidth, setWidth, setWrapTitle, shouldApplyHeightToTextBox, shouldFetchMissingValue, shouldSaveOnEnter, show, showIcon, showPicker, stopHover, updateState, validate, valueClipped`

    - ### Methods inherited from class com.smartgwt.client.core.RefDataClass

      `getRef, getRef, internalSetID`

    - ### Methods inherited from class com.smartgwt.client.core.DataClass

      `doAddHandler, fireEvent, getAttributeAsDoubleArray, getAttributeAsIntArray, getAttributeAsLong, getAttributeAsMap, getAttributeAsObject, getAttributeAsRecord, getAttributeAsStringArray, getAttributes, getHandlerCount, getJsObj, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttributeAsJavaObject`

    - ### Methods inherited from class com.smartgwt.client.core.JsObject

      `equals, hashCode, setJsObj`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

      `fireEvent`

- - ### Constructor Detail

    - #### MultiComboBoxItem

          public MultiComboBoxItem()

    - #### MultiComboBoxItem

          public MultiComboBoxItem(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### MultiComboBoxItem

          public MultiComboBoxItem(java.lang.String name)

    - #### MultiComboBoxItem

          public MultiComboBoxItem(java.lang.String name,
                           java.lang.String title)

  - ### Method Detail

    - #### getOrCreateRef

          public static MultiComboBoxItem getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### setJavaScriptObject

          public void setJavaScriptObject(com.google.gwt.core.client.JavaScriptObject jsObj)

      Overrides:
        `setJavaScriptObject` in class `CanvasItem`

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                     Canvas defaults)

      Changes the defaults for Canvas AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - Canvas defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties.
      See Also:
        `AutoChildUsage`

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                     FormItem defaults)

      Changes the defaults for FormItem AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - FormItem defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties.
      See Also:
        `AutoChildUsage`

    - #### changePickerIconDefaults

          public static void changePickerIconDefaults(FormItemIcon defaults)

    - #### setAutoFetchData

          public void setAutoFetchData(java.lang.Boolean autoFetchData)

      Should the MultiComboBoxItem fetch data from the `data source` immediately or wait until the user first opens the pickList.
      Parameters:
        `autoFetchData` - autoFetchData Default value is false
      See Also:
        `ComboBoxItem.setAutoFetchData(java.lang.Boolean)`

    - #### getAutoFetchData

          public java.lang.Boolean getAutoFetchData()

      Should the MultiComboBoxItem fetch data from the `data source` immediately or wait until the user first opens the pickList.
      Returns:
        Boolean
      See Also:
        `ComboBoxItem.getAutoFetchData()`

    - #### setAutoFitButtons

          public void setAutoFitButtons(java.lang.Boolean autoFitButtons)

      Specifies whether to autofit the buttons in the MultiComboBoxItem. The default value is true if `layoutStyle` is "flow", but false for a layoutStyle of "vertical" or "verticalReverse". If the `layoutStyle` is "horizontal" or "horizontalReverse" then the buttons will autofit regardless of the setting of this property.
      If this method is called after the component has been drawn/initialized: Sets the `autoFitButtons` property.
      Parameters:
        `autoFitButtons` - whether to autofit the buttons. Default value is null

    - #### getAutoFitButtons

          public java.lang.Boolean getAutoFitButtons()

      Specifies whether to autofit the buttons in the MultiComboBoxItem. The default value is true if `layoutStyle` is "flow", but false for a layoutStyle of "vertical" or "verticalReverse". If the `layoutStyle` is "horizontal" or "horizontalReverse" then the buttons will autofit regardless of the setting of this property.
      Returns:
        Boolean

    - #### setComboBoxWidth

          public void setComboBoxWidth(java.lang.Integer comboBoxWidth)

      Specifies the size of the combo box field.

      Note that this attribute only has an effect in "flow", "horizontal", and "horizontalReverse" `modes`. In the other modes, the combo box is as wide as the overall MultiComboBoxItem.

      Parameters:
        `comboBoxWidth` - comboBoxWidth Default value is null

    - #### getComboBoxWidth

          public java.lang.Integer getComboBoxWidth()

      Specifies the size of the combo box field.

      Note that this attribute only has an effect in "flow", "horizontal", and "horizontalReverse" `modes`. In the other modes, the combo box is as wide as the overall MultiComboBoxItem.

      Returns:
        Integer

    - #### setDisplayField

          public void setDisplayField(java.lang.String displayField)

      The `displayField` of the combo box.

      Note : This is an advanced setting

      Overrides:
        `setDisplayField` in class `FormItem`
      Parameters:
        `displayField` - . See `String`. Default value is null
      See Also:
        `ComboBoxItem.setDisplayField(java.lang.String)`

    - #### getDisplayField

          public java.lang.String getDisplayField()

      The `displayField` of the combo box.
      Overrides:
        `getDisplayField` in class `FormItem`
      Returns:
        . See `String`
      See Also:
        `ComboBoxItem.getDisplayField()`

    - #### setLayoutStyle

          public void setLayoutStyle(MultiComboBoxLayoutStyle layoutStyle)

      Specifies the layout style of the combo box and the buttons in the MultiComboBoxItem. Available values are "flow" (the default), "horizontal", "horizontalReverse", "vertical", and "verticalReverse".
      - "flow": The buttons appear to the left of the combo box. When there is no more room, the combo box and/or buttons flow onto a new line. The buttons autoFit by default.
      - "horizontal": The combo box appears on right and buttons are horizontally stacked directly left of it. The buttons must autofit.
      - "horizontalReverse": Like "horizontal" but the combo box appears on the left. The buttons must autofit.
      - "vertical": The combo box appears on top and buttons are stacked beneath it. Buttons do not autofit by default.
      - "verticalReverse": Like "vertical" but the combo box appears at bottom. The buttons do not autofit by default.
      Parameters:
        `layoutStyle` - the new layout style. Default value is "flow"

    - #### getLayoutStyle

          public MultiComboBoxLayoutStyle getLayoutStyle()

      Specifies the layout style of the combo box and the buttons in the MultiComboBoxItem. Available values are "flow" (the default), "horizontal", "horizontalReverse", "vertical", and "verticalReverse".
      - "flow": The buttons appear to the left of the combo box. When there is no more room, the combo box and/or buttons flow onto a new line. The buttons autoFit by default.
      - "horizontal": The combo box appears on right and buttons are horizontally stacked directly left of it. The buttons must autofit.
      - "horizontalReverse": Like "horizontal" but the combo box appears on the left. The buttons must autofit.
      - "vertical": The combo box appears on top and buttons are stacked beneath it. Buttons do not autofit by default.
      - "verticalReverse": Like "vertical" but the combo box appears at bottom. The buttons do not autofit by default.
      Returns:
        MultiComboBoxLayoutStyle

    - #### setShouldSaveValue

          public void setShouldSaveValue(java.lang.Boolean shouldSaveValue)

      Should this item's value be saved in the form's values and hence returned from `form.getValues()`?

      `shouldSaveValue:false` is used to mark formItems which do not correspond to the underlying data model and should not save a value into the form's `values`. Example includes visual separators, password re-type fields, or checkboxes used to show/hide other form items.

      A `shouldSaveValue:false` item should be given a value either via `defaultValue` or by calling `form.setValue(item, value)` or `formItem.setValue(value)`. Providing a value via `form.values` or `form.setValues()` will automatically switch the item to `shouldSaveValue:true`.

      Note that

      - if an item is shouldSaveValue true, but has no name, a warning is logged, and shouldSaveValue will be set to false.
      Overrides:
        `setShouldSaveValue` in class `CanvasItem`
      Parameters:
        `shouldSaveValue` - shouldSaveValue Default value is true

    - #### getShouldSaveValue

          public java.lang.Boolean getShouldSaveValue()

      Should this item's value be saved in the form's values and hence returned from `form.getValues()`?

      `shouldSaveValue:false` is used to mark formItems which do not correspond to the underlying data model and should not save a value into the form's `values`. Example includes visual separators, password re-type fields, or checkboxes used to show/hide other form items.

      A `shouldSaveValue:false` item should be given a value either via `defaultValue` or by calling `form.setValue(item, value)` or `formItem.setValue(value)`. Providing a value via `form.values` or `form.setValues()` will automatically switch the item to `shouldSaveValue:true`.

      Note that

      - if an item is shouldSaveValue true, but has no name, a warning is logged, and shouldSaveValue will be set to false.
      Overrides:
        `getShouldSaveValue` in class `CanvasItem`
      Returns:
        Boolean

    - #### setUseInsertionOrder

          public void setUseInsertionOrder(java.lang.Boolean useInsertionOrder)

      Specifies whether to arrange the buttons of the MultiComboBoxItem in the order that they were selected (the default), or to sort the buttons by `displayField`.
      Parameters:
        `useInsertionOrder` - useInsertionOrder Default value is true

    - #### getUseInsertionOrder

          public java.lang.Boolean getUseInsertionOrder()

      Specifies whether to arrange the buttons of the MultiComboBoxItem in the order that they were selected (the default), or to sort the buttons by `displayField`.
      Returns:
        Boolean

    - #### setValueField

          public void setValueField(java.lang.String valueField)

      The `valueField` of the combo box.
      Overrides:
        `setValueField` in class `FormItem`
      Parameters:
        `valueField` - . See `String`. Default value is null
      See Also:
        `ComboBoxItem.setValueField(java.lang.String)`

    - #### getValueField

          public java.lang.String getValueField()

      The `valueField` of the combo box.
      Overrides:
        `getValueField` in class `FormItem`
      Returns:
        . See `String`
      See Also:
        `ComboBoxItem.getValueField()`

    - #### showValue

          public void showValue(java.lang.Object displayValue,
                       java.lang.Object dataValue,
                       DynamicForm form,
                       CanvasItem item)

      This method will be called whenever this form item's value is being set via a programmatic call to e.g: `DynamicForm.setValues` or `FormItem.setValue` and may be overridden by CanvasItems intended to support displaying data values to update the embedded Canvas to reflect the value passed in.
      Parameters:
        `displayValue` - new display-value for the item. This is the value after applying any custom formatter or valueMap
        `dataValue` - underlying data value for the item
        `form` - the dynamicForm in which this item is contained
        `item` - the live form item instance

    - #### setDefaultProperties

          public static void setDefaultProperties(MultiComboBoxItem multiComboBoxItemProperties)

      Class level method to set the default properties of this class. If set, then all subsequent instances of this class will automatically have the default properties that were set when this method was called. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

      Note: This method is intended for setting default attributes only and will effect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead.

      Parameters:
        `multiComboBoxItemProperties` - properties that should be used as new defaults when instances of this class are created

    - #### getButtonDefaults

          public IButton getButtonDefaults()

      Default properties to be used in creating each `IButton`.
      Returns:
        IButton

    - #### setButtonProperties

          public void setButtonProperties(IButton buttonProperties)

      Properties to be used in creating each option button.

      Note : This is an advanced setting

      Parameters:
        `buttonProperties` - buttonProperties

    - #### getButtonProperties

          public IButton getButtonProperties()

      Properties to be used in creating each option button.
      Returns:
        IButton

    - #### getComboBoxDefaults

          public ComboBoxItem getComboBoxDefaults()

      Default properties for the `ComboBoxItem` in a MultiComboBoxItem.
      Returns:
        ComboBoxItem

    - #### setComboBoxProperties

          public void setComboBoxProperties(ComboBoxItem comboBoxProperties)

      Properties to be used in creating a `ComboBoxItem`.

      Note : This is an advanced setting

      Parameters:
        `comboBoxProperties` - comboBoxProperties Default value is null

    - #### getComboBoxProperties

          public ComboBoxItem getComboBoxProperties()

      Properties to be used in creating a `ComboBoxItem`.
      Returns:
        ComboBoxItem

    - #### setOptionDataSource

          public void setOptionDataSource(DataSource optionDataSource)

      The `optionDataSource` of the combo box.
      Overrides:
        `setOptionDataSource` in class `FormItem`
      Parameters:
        `optionDataSource` - optionDataSource Default value is null
      See Also:
        `ComboBoxItem.setOptionDataSource(com.smartgwt.client.data.DataSource)`

    - #### getOptionDataSource

          public DataSource getOptionDataSource()

      The `optionDataSource` of the combo box.
      Returns:
        DataSource
      See Also:
        `ComboBoxItem.getOptionDataSource()`

    - #### getValues

          public final java.lang.String[] getValues()

    - #### setValues

          public void setValues(java.lang.Object... values)